/*******************************************************************************
*
* Title: ll1.h
*
* Description:  Layer1 common header
*
* Written By:	Konrad Hammel (konrad@sangoma.com)
				David Yat Sin (dyatsin@sangoma.com)
*
* Date: 2010-06-06
*
*******************************************************************************/
#ifndef __LL1_H_
#define __LL1_H_
/******************************************************************************/

/* INCLUDES *******************************************************************/
/******************************************************************************/

/* DEFINES ********************************************************************/
#define MAXL1UI         1
#define MAXL1MI         1


#define LL1_REASON_CONNECTED					0x01
#define LL1_REASON_DISCONNECTED					0x02
#define LL1_REASON_CON_REQ_SUCCESSFUL			0x03
#define LL1_REASON_CON_REQ_FAIL					0x04
#define LL1_REASON_CON_REQ_ALREADY_ACTIVE		0x05
#define LL1_REASON_DISCON_REQ					0x06
#define LL1_REASON_RX_ERROR_INVALID_SIZE		0x07
#define LL1_REASON_TX_SUCCESSFUL				0x08
#define LL1_REASON_RX_SUCCESSFUL				0x09

#define ELL1BASE       0            /* reserved */
#define ELL1XXX        (ELL1BASE)   /* reserved */

enum {
	SNG_L1_TYPE_PRI = 1,
	SNG_L1_TYPE_BRI,
	SNG_L1_TYPE_SS7,
}sng_l1_type_t;


/******************************************************************************/

/* GLOBALS ********************************************************************/
/******************************************************************************/

/* FUNCTION PROTOTYPES ********************************************************/
/******************************************************************************/

/******************************************************************************/
#endif /* __LL1_H_ */
/******************************************************************************/
