/********************************************************************16**

                         (c) COPYRIGHT 1989-2003 by 
                         Continuous Computing Corporation.
                         All rights reserved.

     This software is confidential and proprietary to Continuous Computing 
     Corporation (CCPU).  No part of this software may be reproduced,
     stored, transmitted, disclosed or used in any form or by any means
     other than as expressly provided by the written Software License 
     Agreement between CCPU and its licensee.

     CCPU warrants that for a period, as provided by the written
     Software License Agreement between CCPU and its licensee, this
     software will perform substantially to CCPU specifications as
     published at the time of shipment, exclusive of any updates or 
     upgrades, and the media used for delivery of this software will be 
     free from defects in materials and workmanship.  CCPU also warrants 
     that has the corporate authority to enter into and perform under the   
     Software License Agreement and it is the copyright owner of the software 
     as originally delivered to its licensee.

     CCPU MAKES NO OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING
     WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR
     A PARTICULAR PURPOSE WITH REGARD TO THIS SOFTWARE, SERVICE OR ANY RELATED
     MATERIALS.

     IN NO EVENT SHALL CCPU BE LIABLE FOR ANY INDIRECT, SPECIAL,
     CONSEQUENTIAL DAMAGES, OR PUNITIVE DAMAGES IN CONNECTION WITH OR ARISING
     OUT OF THE USE OF, OR INABILITY TO USE, THIS SOFTWARE, WHETHER BASED
     ON BREACH OF CONTRACT, TORT (INCLUDING NEGLIGENCE), PRODUCT
     LIABILITY, OR OTHERWISE, AND WHETHER OR NOT IT HAS BEEN ADVISED
     OF THE POSSIBILITY OF SUCH DAMAGE.

                       Restricted Rights Legend

     This software and all related materials licensed hereby are
     classified as "restricted computer software" as defined in clause
     52.227-19 of the Federal Acquisition Regulation ("FAR") and were
     developed entirely at private expense for nongovernmental purposes,
     are commercial in nature and have been regularly used for
     nongovernmental purposes, and, to the extent not published and
     copyrighted, are trade secrets and confidential and are provided
     with all rights reserved under the copyright laws of the United
     States.  The government's rights to the software and related
     materials are limited and restricted as provided in clause
     52.227-19 of the FAR.

                    IMPORTANT LIMITATION(S) ON USE

     The use of this software is limited to the use set
     forth in the written Software License Agreement between CCPU and
     its Licensee. Among other things, the use of this software
     may be limited to a particular type of Designated Equipment, as 
     defined in such Software License Agreement.
     Before any installation, use or transfer of this software, please
     consult the written Software License Agreement or contact CCPU at
     the location set forth below in order to confirm that you are
     engaging in a permissible use of the software.

                    Continuous Computing Corporation
                    9380, Carroll Park Drive
                    San Diego, CA-92121, USA

                    Tel: +1 (858) 882 8800
                    Fax: +1 (858) 777 3388

                    Email: support@trillium.com
                    Web: http://www.ccpu.com

*********************************************************************17*/

/********************************************************************20**

     Name:    M2UA-NIF Layer (M2UA)

     Type:    Header File 

     Desc:    HashDefines for NIF-LM Interface 

     File:    lnw.h

     Sid:      lnw.h@@/main/2 - Wed Aug 13 12:02:40 2003

     Prg:     

*********************************************************************21*/

/* unsolicited status */
#define LNW_MAX_TRC_LEN       200   /* Maximum trace size */

/* defines for element management */
#define STNWGEN               1     /* General */
#define STNWDLSAP             2     /* Upper layer SAP */

/* Management events */
#define EVTLNWCFGREQ          1   /* Configuration request */
#define EVTLNWCFGCFM          2   /* Configuration confirm */
#define EVTLNWSTAREQ          3   /* Status request */
#define EVTLNWSTACFM          4   /* Status confirm */
#define EVTLNWSTAIND          5   /* Status indication */
#define EVTLNWSTSREQ          6   /* Statistics request */
#define EVTLNWSTSCFM          7   /* Statistics confirm */
#define EVTLNWTRCIND          8   /* Trace indication */
#define EVTLNWCNTRLREQ        9   /* Control request */
#define EVTLNWCNTRLCFM        10  /* Control confirm */

/* status */
#define LNW_SAP_UNBOUND        1  /* SAP not bound */
#define LNW_SAP_BOUND          2  /* SAP has been bound */

/* operation in progress */
#define LNW_M2UA_SAP_BIND      1  /* M2UA SAP binding in progress */
#define LNW_MTP2_SAP_BIND      1  /* M2UA SAP binding in progress */

/* trace indication */
#define LNW_MTP2_MSG_RX                 1  /* Message Receive from MTP2 */
#define LNW_MTP2_MSG_TX                 2  /* Message Transmit to MTP2 */
#define LNW_M2UA_MSG_RX                 3  /* Message Receive from M2UA */
#define LNW_M2UA_MSG_TX                 4  /* Message Transmit to M2UA */

#define LNW_REASON_RECONFIG_OK      (LCM_REASON_LYR_SPECIFIC + 1) /* Reconfiguration attempt */

/* Message and packing macros */
#define LNWLOGERROR(errCls, errCode, errDesc)         \
        SLogError(pst->srcEnt, pst->srcInst, pst->srcProcId,  \
                   __FILE__, __LINE__,                        \
                  (ErrCls)errCls, (ErrCode)errCode, (ErrVal)0, errDesc)

#define LNW_GETMSG(p, m, e) { \
    S16 ret; \
    ret = SGetMsg((p)->region, (p)->pool, &(m)); \
    if (ret != ROK) \
    { \
        LNWLOGERROR(ERRCLS_ADD_RES, e, "SGetMsg failed"); \
        RETVALUE(ret); \
    } \
}
#define LNW_PUTMSG(_msg) { \
    S16 ret; \
    ret = SPutMsg(_msg); \
    _msg = (Buffer *)NULLP; \
    if (ret != ROK) \
    { \
        LNWLOGERROR(ERRCLS_ADD_RES, _msg, "SPutMsg failed"); \
        RETVALUE(ret); \
    } \
}

/* Error codes for functions at the LNW Interface */
#define   ELNWBASE      000
#define   ELNWXXX      (ELNWBASE)         /* reserved */
#define   ERRLNW       (ELNWBASE)         /* reserved */
#define   ELNW001      (ERRLNW +    1)    /*        lnw.c: 300 */
#define   ELNW002      (ERRLNW +    2)    /*        lnw.c: 305 */
#define   ELNW003      (ERRLNW +    3)    /*        lnw.c: 309 */
#define   ELNW004      (ERRLNW +    4)    /*        lnw.c: 315 */
#define   ELNW005      (ERRLNW +    5)    /*        lnw.c: 321 */
#define   ELNW006      (ERRLNW +    6)    /*        lnw.c: 511 */
#define   ELNW007      (ERRLNW +    7)    /*        lnw.c: 516 */
#define   ELNW008      (ERRLNW +    8)    /*        lnw.c: 520 */
#define   ELNW009      (ERRLNW +    9)    /*        lnw.c: 526 */
#define   ELNW010      (ERRLNW +   10)    /*        lnw.c: 575 */
#define   ELNW011      (ERRLNW +   11)    /*        lnw.c: 578 */
#define   ELNW012      (ERRLNW +   12)    /*        lnw.c: 581 */
#define   ELNW013      (ERRLNW +   13)    /*        lnw.c: 582 */
#define   ELNW014      (ERRLNW +   14)    /*        lnw.c: 583 */
#define   ELNW015      (ERRLNW +   15)    /*        lnw.c: 584 */
#define   ELNW016      (ERRLNW +   16)    /*        lnw.c: 585 */
#define   ELNW017      (ERRLNW +   17)    /*        lnw.c: 586 */
#define   ELNW018      (ERRLNW +   18)    /*        lnw.c: 636 */
#define   ELNW019      (ERRLNW +   19)    /*        lnw.c: 637 */
#define   ELNW020      (ERRLNW +   20)    /*        lnw.c: 638 */
#define   ELNW021      (ERRLNW +   21)    /*        lnw.c: 639 */
#define   ELNW022      (ERRLNW +   22)    /*        lnw.c: 640 */
#define   ELNW023      (ERRLNW +   23)    /*        lnw.c: 641 */
#define   ELNW024      (ERRLNW +   24)    /*        lnw.c: 644 */
#define   ELNW025      (ERRLNW +   25)    /*        lnw.c: 764 */
#define   ELNW026      (ERRLNW +   26)    /*        lnw.c: 766 */
#define   ELNW027      (ERRLNW +   27)    /*        lnw.c: 767 */
#define   ELNW028      (ERRLNW +   28)    /*        lnw.c: 768 */
#define   ELNW029      (ERRLNW +   29)    /*        lnw.c: 889 */
#define   ELNW030      (ERRLNW +   30)    /*        lnw.c: 890 */
#define   ELNW031      (ERRLNW +   31)    /*        lnw.c: 891 */
#define   ELNW032      (ERRLNW +   32)    /*        lnw.c: 936 */
#define   ELNW033      (ERRLNW +   33)    /*        lnw.c: 941 */
#define   ELNW034      (ERRLNW +   34)    /*        lnw.c: 945 */
#define   ELNW035      (ERRLNW +   35)    /*        lnw.c: 949 */
#define   ELNW036      (ERRLNW +   36)    /*        lnw.c: 955 */
#define   ELNW037      (ERRLNW +   37)    /*        lnw.c: 960 */
#define   ELNW038      (ERRLNW +   38)    /*        lnw.c: 961 */
#define   ELNW039      (ERRLNW +   39)    /*        lnw.c: 962 */
#define   ELNW040      (ERRLNW +   40)    /*        lnw.c: 963 */
#define   ELNW041      (ERRLNW +   41)    /*        lnw.c:1014 */
#define   ELNW042      (ERRLNW +   42)    /*        lnw.c:1015 */
#define   ELNW043      (ERRLNW +   43)    /*        lnw.c:1016 */
#define   ELNW044      (ERRLNW +   44)    /*        lnw.c:1018 */
#define   ELNW045      (ERRLNW +   45)    /*        lnw.c:1023 */
#define   ELNW046      (ERRLNW +   46)    /*        lnw.c:1028 */
#define   ELNW047      (ERRLNW +   47)    /*        lnw.c:1032 */
#define   ELNW048      (ERRLNW +   48)    /*        lnw.c:1038 */
#define   ELNW049      (ERRLNW +   49)    /*        lnw.c:1198 */
#define   ELNW050      (ERRLNW +   50)    /*        lnw.c:1200 */
#define   ELNW051      (ERRLNW +   51)    /*        lnw.c:1201 */
#define   ELNW052      (ERRLNW +   52)    /*        lnw.c:1202 */
#define   ELNW053      (ERRLNW +   53)    /*        lnw.c:1250 */
#define   ELNW054      (ERRLNW +   54)    /*        lnw.c:1255 */
#define   ELNW055      (ERRLNW +   55)    /*        lnw.c:1259 */
#define   ELNW056      (ERRLNW +   56)    /*        lnw.c:1265 */
#define   ELNW057      (ERRLNW +   57)    /*        lnw.c:1270 */
#define   ELNW058      (ERRLNW +   58)    /*        lnw.c:1271 */
#define   ELNW059      (ERRLNW +   59)    /*        lnw.c:1272 */
#define   ELNW060      (ERRLNW +   60)    /*        lnw.c:1273 */
#define   ELNW061      (ERRLNW +   61)    /*        lnw.c:1274 */
#define   ELNW062      (ERRLNW +   62)    /*        lnw.c:1430 */
#define   ELNW063      (ERRLNW +   63)    /*        lnw.c:1431 */
#define   ELNW064      (ERRLNW +   64)    /*        lnw.c:1432 */
#define   ELNW065      (ERRLNW +   65)    /*        lnw.c:1480 */
#define   ELNW066      (ERRLNW +   66)    /*        lnw.c:1481 */
#define   ELNW067      (ERRLNW +   67)    /*        lnw.c:1482 */
#define   ELNW068      (ERRLNW +   68)    /*        lnw.c:1483 */
#define   ELNW069      (ERRLNW +   69)    /*        lnw.c:1484 */
#define   ELNW070      (ERRLNW +   70)    /*        lnw.c:1489 */
#define   ELNW071      (ERRLNW +   71)    /*        lnw.c:1493 */
#define   ELNW072      (ERRLNW +   72)    /*        lnw.c:1499 */
#define   ELNW073      (ERRLNW +   73)    /*        lnw.c:1548 */
#define   ELNW074      (ERRLNW +   74)    /*        lnw.c:1550 */
#define   ELNW075      (ERRLNW +   75)    /*        lnw.c:1551 */
#define   ELNW076      (ERRLNW +   76)    /*        lnw.c:1601 */
#define   ELNW077      (ERRLNW +   77)    /*        lnw.c:1602 */
#define   ELNW078      (ERRLNW +   78)    /*        lnw.c:1648 */
#define   ELNW079      (ERRLNW +   79)    /*        lnw.c:1650 */
#define   ELNW080      (ERRLNW +   80)    /*        lnw.c:1651 */
#define   ELNW081      (ERRLNW +   81)    /*        lnw.c:1701 */
#define   ELNW082      (ERRLNW +   82)    /*        lnw.c:1702 */
#define   ELNW083      (ERRLNW +   83)    /*        lnw.c:1748 */
#define   ELNW084      (ERRLNW +   84)    /*        lnw.c:1750 */
#define   ELNW085      (ERRLNW +   85)    /*        lnw.c:1751 */
#define   ELNW086      (ERRLNW +   86)    /*        lnw.c:1752 */
#define   ELNW087      (ERRLNW +   87)    /*        lnw.c:1802 */
#define   ELNW088      (ERRLNW +   88)    /*        lnw.c:1803 */
#define   ELNW089      (ERRLNW +   89)    /*        lnw.c:1804 */
#define   ELNW090      (ERRLNW +   90)    /*        lnw.c:1851 */
#define   ELNW091      (ERRLNW +   91)    /*        lnw.c:1860 */
#define   ELNW092      (ERRLNW +   92)    /*        lnw.c:1863 */
#define   ELNW093      (ERRLNW +   93)    /*        lnw.c:1864 */
#define   ELNW094      (ERRLNW +   94)    /*        lnw.c:1865 */
#define   ELNW095      (ERRLNW +   95)    /*        lnw.c:1866 */
#define   ELNW096      (ERRLNW +   96)    /*        lnw.c:1867 */
#define   ELNW097      (ERRLNW +   97)    /*        lnw.c:1918 */
#define   ELNW098      (ERRLNW +   98)    /*        lnw.c:1919 */
#define   ELNW099      (ERRLNW +   99)    /*        lnw.c:1920 */
#define   ELNW100      (ERRLNW +  100)    /*        lnw.c:1921 */
#define   ELNW101      (ERRLNW +  101)    /*        lnw.c:1922 */
#define   ELNW102      (ERRLNW +  102)    /*        lnw.c:1926 */


/********************************************************************30**

  End of file:     lnw.h@@/main/2 - Wed Aug 13 12:02:40 2003

**********************************************************************31*/

/********************************************************************40**

Notes:

**********************************************************************41*/

/********************************************************************50**

**********************************************************************51*/

/********************************************************************60**

  Revision history:

**********************************************************************61*/
/********************************************************************70**

  version    initials                   description
  -----------  ---------  ------------------------------------------------

**********************************************************************71*/

/********************************************************************80**

**********************************************************************81*/

/********************************************************************90**
 
     ver       pat    init                  description
------------ -------- ---- ----------------------------------------------
/main/1      ---     sb   1. initial release.
/main/2      ---     yz   1. Update for release 1.2.
*********************************************************************91*/
